//	Microworks ObjectMate  2.6
//
//  "SFX Class Library"
//
//	An ObjectWindows 2.0 extension for Borland C++ 4.0
//
//	Copyright 1992-94 Microworks Sydney, Australia.
//
//  SFRAME.CPP

#include <owl\owlpch.h>
#include <sfx\sfx200.h>
#include <sfx\sframe.h>

DEFINE_RESPONSE_TABLE1(TSFXFrameWindow, TFrameWindow)
END_RESPONSE_TABLE;

//	constructor for a TSFXFrameWindow object

TSFXFrameWindow::TSFXFrameWindow(TWindow*        parent,
								 const char far* title,
								 TWindow*        clientWnd,
								 BOOL            sfxFrame,
								 BOOL            sfxCaption,
								 BOOL            shrinkToClient,
								 TModule*        module)
	:TFrameWindow(parent, title, clientWnd, shrinkToClient, module)
{
	TWindow::Init(0, title, module);
	if (sfxFrame)
		Attr.Style |= MWS_SFXFRAME;
	else
		Attr.Style |= MWS_3DFRAME;
	if (sfxCaption)
		Attr.Style |= MWS_SFXCAPTION;
}

void
TSFXFrameWindow::SetupWindow()
{
	TFrameWindow::SetupWindow();
	if (Attr.Style & MWS_SFXFRAME)
	{
		::SetClassWord((HWND) ClientWnd->HWindow, GCW_HBRBACKGROUND,
					   (UINT) GetStockObject(LTGRAY_BRUSH));
	}
}

LRESULT
TSFXFrameWindow::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	return SFXDefWindowProc(HWindow, message, wParam, lParam);
}

IMPLEMENT_STREAMABLE2(TSFXFrameWindow, TFrameWindow, TWindow);

void*
TSFXFrameWindow::Streamer::Read(ipstream& is, uint32 /*version*/) const
{
	ReadVirtualBase((TFrameWindow*)GetObject(), is);
	return GetObject();
}

void
TSFXFrameWindow::Streamer::Write(opstream& os) const
{
	WriteVirtualBase((TFrameWindow*)GetObject(), os);
}


